//PROGRAMA PARA EL ANLISIS DE CORTOCIRCUITO 
//EN SISTEMAS DE POTENCIA

function [mensaje]=cortocircuito(caso)
printf ("PROGRAMA PARA EL ANLISIS DE CORTOCIRCUITO\n");
exec(caso);                                                    //Lectura y ejecucin de los 
a=fasor;                                                       //archivos de datos
K=barfal;
txt=['Tensin de prefalla [p.u]';'Impedancia de falla [p.u]'];
sig=x_mdialog('Introduzca las condiciones de cortocircuito',txt,['';'']);
V=evstr(sig(1));
Zf=evstr(sig(2));
Z1=Zbarra(ZA);
Z2=Zbarra(ZB);
Z0=Zbarra(ZC);
//ph=evstr(sig(3))
//V=input ('Digite la tensin de pre-falla en la barra [p.u]: '); //Asignacin de valores por 
//printf ("\n");                                                  //el usuario
//Zf=input ('Valor de impedancia de falla [p.u]:');
tipos=['Trifsica';'Monofsica a tierra';'Bifsica';'Bifsica a tierra'];
caso=x_choose(tipos,['Escoja el tipo de falla a simular']);

//printf ("\n"); 
//printf ("Indique el tipo de falla a simular:\n");               //Seleccin del tipo de falla
//printf ("1.- Si es trifsica\n");                               //hecha por el usuario
//printf ("2.- Si es monofsica a tierra\n");
//printf ("3.- Si es bifsica\n");
//printf ("4.- Si es bifsica a tierra\n");
//caso=input ('Digite la opcin:');printf ("\n");
 
select caso
 
 case 1                                                         //Calculos para falla trifsica
   I=V/Z1(K,K); 
   I=I+1*10^(-9);  
   ang=atan(imag(I)/real(I))*360/(2*%pi);
   printf ("    Corriente            Magnitud        Angulo\n"); //Impresin de resultados
   printf ("                          [p.u]            []\n");
   printf ("Trifsica de falla        %.3f           %.2f\n",abs(I),ang");
  
 case 2
   I0=V/(Z1(K,K)+Z2(K,K)+Z0(K,K)+3*Zf);                         //Calculos para falla monofsica 
   I0=I0+1*10^(-9); 
   I1=I0;                                                       //a tierra
   I2=I0;
   Itotal=3*I0;
   ang1=atan(imag(I1)/real(I1))*360/(2*%pi);
   ang2=atan(imag(I2)/real(I2))*360/(2*%pi);
   ang0=atan(imag(I0)/real(I0))*360/(2*%pi);
   angT=atan(imag(Itotal)/real(Itotal))*360/(2*%pi);
   printf ("    Corriente            Magnitud        Angulo\n");  //Impresin de resultados
   printf ("                          [p.u]            []\n");
   printf ("Secuencia Positiva        %.3f           %.2f\n",abs(I1),ang1");
   printf ("Secuencia Negativa        %.3f           %.2f\n",abs(I2),ang2"); 
   printf ("Secuencia Cero            %.3f           %.2f\n",abs(I0),ang0");
   printf ("Total de Falla            %.3f           %.2f\n",abs(Itotal),angT");
  
    
 case 3        
   I1=V/(Z1(K,K)+Z2(K,K));                                       //Calculos para falla bifsica
   I2=(-1)*I1;
   I1=I1+1*10^(-9); 
   I2=I2+1*10^(-9); 
   Itotal=a^2*I1+a*I2;
   ang1=atan(imag(I1)/real(I1))*360/(2*%pi);
   ang2=atan(imag(I2)/real(I2))*360/(2*%pi);
   angT=atan(imag(Itotal)/real(Itotal))*360/(2*%pi);
   printf ("    Corriente            Magnitud        Angulo\n"); //Impresin de resultados 
   printf ("                          [p.u]            []\n");
   printf ("Secuencia Positiva        %.3f           %.2f\n",abs(I1),ang1");
   printf ("Secuencia Negativa        %.3f           %.2f\n",abs(I2),ang2"); 
   printf ("Total de Falla            %.3f           %.2f\n",abs(Itotal),angT");
   printf ("\nNo existe corriente de secuencia cero\n");
      
 case 4
   I1=V/(Z1(K,K)+((Z2(K,K)*(Z0(K,K)+3*Zf))/(Z2(K,K)+Z0(K,K)+3*Zf))); //Calculos para falla 
   I2=(-1)*I1*((Z0(K,K)+3*Zf)/(Z2(K,K)+Z0(K,K)+3*Zf));               //bifsica a tierra
   I0=(-1)*I1*(Z2(K,K)/(Z2(K,K)+Z0(K,K)+3*Zf));
   I1=I1+1*10^(-9); 
   I2=I2+1*10^(-9); 
   I0=I0+1*10^(-9); 
   Itotal=3*I0;
   ang1=atan(imag(I1)/real(I1))*360/(2*%pi);
   ang2=atan(imag(I2)/real(I2))*360/(2*%pi);
   ang0=atan(imag(I0)/real(I0))*360/(2*%pi);
   angT=atan(imag(Itotal)/real(Itotal))*360/(2*%pi);
   printf ("    Corriente            Magnitud        Angulo\n");     //Impresin de resultados
   printf ("                          [p.u]            []\n");
   printf ("Secuencia Positiva        %.3f           %.2f\n",abs(I1),ang1");
   printf ("Secuencia Negativa        %.3f           %.2f\n",abs(I2),ang2"); 
   printf ("Secuencia Cero            %.3f           %.2f\n",abs(I0),ang0");
   printf ("Total de Falla            %.3f           %.2f\n",abs(Itotal),angT");
   
 else
   printf ("Caso no encontrado\n");                           //En caso de no identificar el caso    
end

mensaje='FIN DEL ANLISIS';
endfunction


