//Funcin de interfaz grfica con el usuario
//Se despliegan diferentes menus para realizar el anlisis 
j=sqrt(-1);
opciones=['Flujo de carga';'Despacho Econmico';
          'Estabilidad';'Cortocircuito';
          'Ybarra';'Zbarra';'Salir del programa'];
sistemas=['Caso 5 (Sistema de potencia de 5 barras)';'Caso 9 (Sistema de potencia de 9 barras)'];
n=x_choose(opciones,['Funciones para el anlisis de Sistemas de Potencia';'Elija una funcin']);
select n
 case 1
  m=x_choose (['Mtodo de Gauss-Seidel';'Mtodo de Newton-Raphson'],['Mtodos de anlisis de Flujo de carga';'Elija un mtodo']);
  l=x_choose(['Caso predeterminado';'Nuevo caso'],['Sistema de potencia a analizar']);
   select l
    case 1
     o=x_choose(sistemas,['Casos predeterminados en el toolbox';'Elija un caso']);
     select m
      case 1
       select o
        case 1
         gauss_seidel('caso5');
        case 2
         gauss_seidel('caso9');
       end
      case 2
       select o
        case 1
         newton_raphson('caso5');
        case 2
         newton_raphson('caso9');
       end
     end
    case 2
     txt=['nombre del archivo'];
     sig=x_mdialog('Entre el nombre del archivo',txt,[' ']);
     select m
      case 1
       gauss_seidel(sig);
      case 2
       newton_raphson(sig); 
     end
   end  
 case 2
  m=x_choose (['Sin considerar perdidas';'Considerando perdidas'],['Tipos de anlisis de despacho econmico';'Escoja una opcin']);
  l=x_choose(['Caso predeterminado';'Nuevo caso'],['Sistema de potencia a analizar']);
   select l
    case 1
     o=x_choose(sistemas,['Casos predeterminados en el toolbox';'Elija un caso']);
     select m
      case 1
       select o
        case 1
         despacho1('caso5');
        case 2
         despacho1('caso9');
       end
      case 2
       select o
        case 1
         despacho2('caso5');
        case 2
         despacho2('caso9');
       end
     end
    case 2
     txt=['nombre del archivo'];
     sig=x_mdialog('Entre el nombre del archivo',txt,[' ']);
     select m
      case 1
       despacho1(sig);
      case 2
       despacho2(sig); 
     end
   end
 case 3
  m=x_choose (['Mtodo de Euler modificado';'Mtodo de Runge-Kutta';'Mtodo Trapezoidal'],['Mtodos de estudio de estabilidad';'Elija un mtodo']);
  l=x_choose(['Caso predeterminado';'Nuevo caso'],['Sistema de potencia a analizar']);
   select l
    case 1
     o=x_choose(sistemas,['Casos predeterminados en el toolbox';'Elija un caso']);
     select m
      case 1
       select o
        case 1
         euler_mod('caso5');
        case 2
         euler_mod('caso9');
       end
      case 2
       select o
        case 1
         runge_kutta('caso5');
        case 2
         runge_kutta('caso9');
       end
      case 3
       select o
        case 1
         trapezoidal('caso5');
        case 2
         trapezoidal('caso9');
       end 
     end
    case 2
     txt=['nombre del archivo'];
     sig=x_mdialog('Entre el nombre del archivo',txt,[' ']);
     select m
      case 1
       euler_mod(sig);
      case 2
       runge_kutta(sig); 
      case 3
       trapezoidal(sig);
     end
   end
 case 4
  l=x_choose(['Caso predeterminado';'Nuevo caso'],['Sistema de potencia a analizar']);
   select l
    case 1
     o=x_choose(sistemas,['Casos predeterminados en el toolbox';'Elija un caso']);
     select o
      case 1
       cortocircuito('caso5');
      case 2
       cortocircuito('caso9');
     end
    case 2
     txt=['nombre del archivo'];
     sig=x_mdialog('Entre el nombre del archivo',txt,[' ']);
     cortocircuito(sig);
   end
 case 5
  l=x_choose(['Caso predeterminado';'Nuevo caso'],['Sistema de potencia a analizar']);
   select l
    case 1
     o=x_choose(sistemas,['Casos predeterminados en el toolbox';'Elija un caso']);
     select o
      case 1
       Ybarra('caso5')
      case 2
       Ybarra('caso9')
     end
    case 2
     txt=['nombre del archivo'];
     sig=x_mdialog('Entre el nombre del archivo',txt,[' ']);
     Ybarra(sig)
   end
 case 6
  l=x_choose(['Caso predeterminado';'Nuevo caso'],['Sistema de potencia a analizar']);
   select l
    case 1
     ejemplo=['Ejemplo1';'Ejemplo2';'Ejemplo3'];
     o=x_choose(ejemplo,['Casos predeterminados en el toolbox';'Elija un caso']);
     select o
      case 1
       Zbarra('Ejemplo1')
      case 2
       Zbarra('Ejemplo2')
      case 3
       Zbarra('Ejemplo3')
     end
    case 2
     txt=['nombre del archivo'];
     sig=x_mdialog('Entre el nombre del archivo',txt,[' ']);
     Zbarra(sig);
   end 
 else
  abort;
end  
ind=x_message(['Sr. Usuario';'Desea continuar en la aplicacin?'],['Si','No']);
if (ind==1)
 exec ('interfaz.sci'); 
else
 abort;
end 
